/*@cc_on _d=document;eval('var document=_d')@*/

//上画像ファイル名
var COVER_IMG = "image/cimg.jpg";

//下地画像ファイル名
var BASE_IMG = "image/bimg.jpg";

//ブラシサイズ
var BRUSH_SIZE = 18;

//画像オブジェクト
var img = new Image();
//画像オブジェクト
var cimg = new Image();

//描画スイッチ
var DrowSwitch = false;

//破れ画像
var tear_img = new Array();
tear_img[0] = new Image();
tear_img[1] = new Image();
tear_img[2] = new Image();
//破れブラシ読み込み
tear_img[0].src = "image/edge/tear_00.png";
tear_img[1].src = "image/edge/tear_01.png";
tear_img[2].src = "image/edge/tear_10.png";

//破れブラシサイズ
var TEAR_BRUCH_SIZE = 8;

//破れ画像の元サイズ
var TEAR_WIDTH = 60;
var TEAR_HEIGHT = 60;

//UA IE以外:0 IE:1 iPhone:2
var MS_UA = navigator.userAgent.toLowerCase();
if(MS_UA.indexOf("msie") > -1){		//IE
	if (navigator.appVersion.indexOf("MSIE 9.0") > -1) {
		MS_UA = 0;
	}else{
		MS_UA = 1;
	}
}else if (MS_UA.match(/iPhone|iPad/i)) {
	MS_UA = 2;
}else{
	MS_UA = 0;
}

//
//getElementByIdを簡単にする記述
function $(e) { return document.getElementById(e); }

function drowImage(e) {
	if(DrowSwitch) {
		var ctx = $('ms-canvas').getContext('2d');
		var mpos = getMousePoint(e);		//マウス座標
		
		var vx = mpos.x;
		var vy = mpos.y;
		
		var bs = BRUSH_SIZE;
		var bsr = bs/2;
		
		if ( vx >= bsr && vy >= bsr) {
			//ctx.beginPath();
			ctx.rect(vx-bsr, vy-bsr, bs, bs);		//パス取得用に下塗り
			ctx.drawImage(img, vx-bsr, vy-bsr, bs, bs, vx-bsr, vy-bsr, bs, bs);
			
			//破れエフェクトはIE非対応にします。
			if(MS_UA == 0){	//IE以外
				//周辺のやぶれたとこ
				var tbs = TEAR_BRUCH_SIZE;
				var tbsr = tbs/2;
				var t_width = TEAR_WIDTH;
				var t_height = TEAR_HEIGHT;
				
				//描画対象座標
				var tpos = new Array();
				//上の方
				tpos[0] = { x:vx-bsr-tbsr+2, y:vy-bsr-tbsr+2, bx:1, by:1, brush:2 };
				tpos[1] = { x:vx-bsr+(tbsr/2), y:vy-bsr-tbsr, bx:2, by:1, brush:2 };
				tpos[2] = { x:vx+bsr, y:vy-bsr-tbsr+2, bx:1, by:1, brush:2  };
				//左の方
				tpos[3] = { x:vx-bsr-tbsr, y:vy-bsr, bx:1, by:2, brush:1 };
				tpos[4] = { x:vx-bsr-tbsr, y:vy+bsr-(tbsr/2), bx:1, by:1, brush:0  };
				//下の方
				tpos[5] = { x:vx-bsr+(tbsr/2), y:vy+bsr+(tbsr/2)-1, bx:2, by:1, brush:0 };
				tpos[6] = { x:vx+bsr-(tbsr/2), y:vy+bsr+(tbsr/2)-1, bx:1, by:1, brush:1 };
				//右の方
				tpos[7] = { x:vx+bsr+(tbsr/2), y:vy-bsr, bx:1, by:2, brush:1 };
				tpos[8] = { x:vx+bsr+(tbsr/2), y:vy, bx:1, by:2, brush:0 };
				//破れ箇所描画
				for (i=0; i < tpos.length; i++) {
					if(!ctx.isPointInPath(tpos[i].x, tpos[i].y)){
						if(tpos[i].x >= 0 && tpos[i].y >= 0){
							ctx.drawImage(tear_img[tpos[i].brush], 0, 0, t_width, t_height, tpos[i].x, tpos[i].y, tbs*tpos[i].bx, tbs*tpos[i].by);
						}
					}
				}
			}
		}
	}
}
//キャンバスの初期化
function initCoverImage() {
	var c = $('canvas-base');
	var cv = $('ms-canvas');
	if(MS_UA != 1){	//IE以外
		c.innerHTML = '<canvas id="ms-canvas" width="'+cv.width+'" height="'+cv.height+'"></canvas>';
		c.innerHTML += '<div><button class="mousatsu-reset" onclick="initCoverImage();">Reset</button></div>';
	}
	initFuncs();
	var ctx = $('ms-canvas').getContext('2d');
	ctx.drawImage(cimg, 0, 0, cv.width, cv.height);
}

//マウス座標取得
function getMousePoint(e) {
	var obj = new Object();
	if(MS_UA == 0){	//IE以外
		var rect = e.target.getBoundingClientRect();
		obj.x = e.clientX - rect.left;
		obj.y = e.clientY - rect.top;
	}else{
		var rect = getElementScreenPosition($("ms-canvas"));
		obj.x = Math.floor(window.event.clientX + document.body.scrollLeft - rect.left);
		obj.y = Math.floor(window.event.clientY + document.body.scrollTop - rect.top);
	}
	
	//alert(obj.x+" "+obj.y);
	return obj;
}
//canvasの座標取得
function getElementScreenPosition(elem) {
  var html = document.documentElement;
  var rect = elem.getBoundingClientRect();
  var left = rect.left - html.clientLeft;
  var top = rect.top - html.clientTop;
  return {left:left, top:top};
}

//キャンバスの関数設定
function initFuncs() {
	var c = $("ms-canvas");
	c.onmousemove = (function() { var e = arguments[0] || window.event; drowImage(e)});
	if(MS_UA == 1){			//IE
		c.onclick = (function() { if (DrowSwitch) { DrowSwitch = false; } else {  DrowSwitch = true; } });
	}else if(MS_UA == 2){		//iPhone, iPad
		c.ontouchstart = (function() { DrowSwitch = true; });
		c.ontouchend = (function() { DrowSwitch = false; });
		c.ontouchcancel = (function() { DrowSwitch = false; });
		c.ontouchmove = (function() { var e = arguments[0] || window.event; drowImage(e)});
	}else{
		c.onmousedown = (function() { DrowSwitch = true; });
		c.onmouseup = (function() { DrowSwitch = false; });
		c.onmouseout = (function() { DrowSwitch = false; });
	}
}

window.onload = function () {
	
	img.src = BASE_IMG;
	cimg.src = COVER_IMG;
	cimg.onload = (function() {
		initCoverImage();
	});
}